const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const provinces = sequelize.define(
    'provinces',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"inactive"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  provinces.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.provinces.hasMany(db.allocations, {
      as: 'allocations_province',
      foreignKey: {
          name: 'provinceId',
      },
      constraints: false,
    });




    db.provinces.hasMany(db.requisitions, {
      as: 'requisitions_province',
      foreignKey: {
          name: 'provinceId',
      },
      constraints: false,
    });









    db.provinces.hasMany(db.projects, {
      as: 'projects_province',
      foreignKey: {
          name: 'provinceId',
      },
      constraints: false,
    });










    db.provinces.hasMany(db.beneficiaries, {
      as: 'beneficiaries_province',
      foreignKey: {
          name: 'provinceId',
      },
      constraints: false,
    });















//end loop



    db.provinces.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });




    db.provinces.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.provinces.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return provinces;
};


